package PERPathPlanner;

import java.util.LinkedList;
import java.util.ArrayList;

/**
 * Helper class for storing an Obstacle consisting of a LinkedList of edges
 * @author David
 *
 */
public class Obstacle {
	LinkedList edges; 
	
	//contains the bounds of the obstacle, updated as edges are added
	float minX,minY,maxX,maxY; 
	
	/**
	 * @param args
	 */
	public Obstacle() {
		edges = new LinkedList();
	}
	public void addEdge(Edge e) {
		edges.add(e);
		//if this is the first edge being added, then this will be all extremes
		if (edges.size()==0) {
			minX = e.getMinX();
			minY = e.getMinY();
			maxX = e.getMaxX();
			maxX = e.getMaxY();
		}
		else { 
			if (minX>e.getMinX()) {
				minX = e.getMinX();
			}
			if (minY>e.getMinY()) {
				minY = e.getMinY();
			}
			if (maxX<e.getMaxX()) {
				maxX = e.getMaxX();
			}
			if (maxY<e.getMaxY()) {
				maxY = e.getMaxY();
			}
		}
	}
	public Edge[] getEdgeArray() { 
		return (Edge[]) edges.toArray(new Edge[0]);
	}
	public float getMinX() { 
		return this.minX;
	}
	public float getMinY() { 
		return this.minY;
	}
	public float getMaxX() {
		return this.maxX;
	}
	public float getMaxY() { 
		return this.maxY;
	}
	
	public ArrayList listVertices(){
		ArrayList vertices = new ArrayList();
		for(int i = 0; i < edges.size(); i++){
			vertices.add(((Edge)edges.get(i)).v1);
		}
		return vertices;
	}
}
